Index: drivers/media/video/bttv-if.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/media/video/bttv-if.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/media/video/bttv-if.c	22 Jul 2004 19:50:19 -0000	1.1
+++ drivers/media/video/bttv-if.c	4 Aug 2004 01:29:02 -0000	1.2
@@ -25,16 +25,12 @@
     
 */
 
-#define __NO_VERSION__ 1
-
-#include <linux/version.h>
 #include <linux/module.h>
 #include <linux/init.h>
 
 #include <asm/io.h>
 
 #include "bttvp.h"
-#include "tuner.h"
 
 static struct i2c_algo_bit_data bttv_i2c_algo_template;
 static struct i2c_adapter bttv_i2c_adap_template;
@@ -194,6 +190,7 @@
 	return state;
 }
 
+#ifndef I2C_PEC
 static void bttv_inc_use(struct i2c_adapter *adap)
 {
 	MOD_INC_USE_COUNT;
@@ -203,10 +200,11 @@
 {
 	MOD_DEC_USE_COUNT;
 }
+#endif
 
 static int attach_inform(struct i2c_client *client)
 {
-        struct bttv *btv = (struct bttv*)client->adapter->data;
+        struct bttv *btv = i2c_get_adapdata(client->adapter);
 
 	if (btv->tuner_type != UNSET)
 		bttv_call_i2c_clients(btv,TUNER_SET_TYPE,&btv->tuner_type);
@@ -216,22 +214,15 @@
 
         if (bttv_debug)
 		printk("bttv%d: i2c attach [client=%s]\n",
-		       btv->nr,client->name);
+		       btv->nr, i2c_clientname(client));
         return 0;
 }
 
 void bttv_call_i2c_clients(struct bttv *btv, unsigned int cmd, void *arg)
 {
-	int i;
-	
-	for (i = 0; i < I2C_CLIENTS_MAX; i++) {
-		if (NULL == btv->i2c_adap.clients[i])
-			continue;
-		if (NULL == btv->i2c_adap.clients[i]->driver->command)
-			continue;
-		btv->i2c_adap.clients[i]->driver->command
-			(btv->i2c_adap.clients[i],cmd,arg);
-	}
+	if (0 != btv->i2c_rc)
+		return;
+	i2c_clients_command(&btv->i2c_adap, cmd, arg);
 }
 
 void bttv_i2c_call(unsigned int card, unsigned int cmd, void *arg)
@@ -252,16 +243,23 @@
 };
 
 static struct i2c_adapter bttv_i2c_adap_template = {
+#ifdef I2C_PEC
+	.owner             = THIS_MODULE,
+#else
 	.inc_use           = bttv_inc_use,
 	.dec_use           = bttv_dec_use,
-	.name              = "bt848",
+#endif
+#ifdef I2C_ADAP_CLASS_TV_ANALOG
+	.class             = I2C_ADAP_CLASS_TV_ANALOG,
+#endif
+	I2C_DEVNAME("bt848"),
 	.id                = I2C_HW_B_BT848,
 	.client_register   = attach_inform,
 };
 
 static struct i2c_client bttv_i2c_client_template = {
-        .name = "bttv internal use only",
-        .id   = -1,
+	I2C_DEVNAME("bttv internal"),
+        .id       = -1,
 };
 
 
@@ -335,10 +333,10 @@
 	memcpy(&btv->i2c_client, &bttv_i2c_client_template,
 	       sizeof(struct i2c_client));
 
-	sprintf(btv->i2c_adap.name+strlen(btv->i2c_adap.name),
-		" #%d", btv->nr);
+	sprintf(btv->i2c_adap.name, "bt848 #%d", btv->nr);
+
         btv->i2c_algo.data = btv;
-        btv->i2c_adap.data = btv;
+        i2c_set_adapdata(&btv->i2c_adap, btv);
         btv->i2c_adap.algo_data = &btv->i2c_algo;
         btv->i2c_client.adapter = &btv->i2c_adap;
 
Index: drivers/media/video/bttv.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/media/video/bttv.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/media/video/bttv.h	22 Jul 2004 19:50:18 -0000	1.1
+++ drivers/media/video/bttv.h	4 Aug 2004 01:29:02 -0000	1.2
@@ -90,6 +90,7 @@
 #define BTTV_SENSORAY311    0x49
 #define BTTV_RV605          0x4a
 #define BTTV_WINDVR         0x4c
+#define BTTV_GRANDTEC       0x4d
 #define BTTV_KWORLD         0x4e
 #define BTTV_HAUPPAUGEPVR   0x50
 #define BTTV_GVBCTV5PCI     0x51
@@ -110,6 +111,10 @@
 #define BTTV_EURESYS_PICOLO 0x61
 #define BTTV_PV150          0x62
 #define BTTV_AD_TVK503      0x63
+#define BTTV_IVC200         0x66
+#define BTTV_XGUARD         0x67
+#define BTTV_NEBULA_DIGITV  0x68
+#define BTTV_PV143          0x69
 
 /* i2c address list */
 #define I2C_TSA5522        0xc2
@@ -247,7 +252,6 @@
 
 
 /* i2c */
-#define I2C_CLIENTS_MAX 16
 extern void bttv_bit_setscl(void *data, int state);
 extern void bttv_bit_setsda(void *data, int state);
 extern void bttv_call_i2c_clients(struct bttv *btv, unsigned int cmd, void *arg);
Index: drivers/media/video/bttvp.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/media/video/bttvp.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/media/video/bttvp.h	22 Jul 2004 19:50:19 -0000	1.1
+++ drivers/media/video/bttvp.h	4 Aug 2004 01:29:02 -0000	1.2
@@ -25,7 +25,8 @@
 #ifndef _BTTVP_H_
 #define _BTTVP_H_
 
-#define BTTV_VERSION_CODE KERNEL_VERSION(0,7,104)
+#include <linux/version.h>
+#define BTTV_VERSION_CODE KERNEL_VERSION(0,7,108)
 
 #include <linux/types.h>
 #include <linux/wait.h>
@@ -35,6 +36,8 @@
 #include "bt848.h"
 #include "bttv.h"
 #include "audiochip.h"
+#include "tuner.h"
+#include "i2c-compat.h"
 
 #ifdef __KERNEL__
 
@@ -53,8 +56,7 @@
 #define dprintk		if (bttv_debug)   printk
 #define vprintk		if (bttv_verbose) printk
 
-/* Anybody who uses more than four? */
-#define BTTV_MAX 4
+#define BTTV_MAX 16
 extern unsigned int bttv_num;			/* number of Bt848s in use */
 extern struct bttv bttvs[BTTV_MAX];
 
@@ -129,6 +131,7 @@
         unsigned int tuner_type;
         unsigned int pinnacle_id;
         unsigned int channel;
+	unsigned int svhs;
         
         unsigned int nr;
 	unsigned short id;
@@ -148,6 +151,7 @@
 	int audio_chip;      /* set to one of the chips supported by bttv.c */
 	int radio;
 	int has_radio;
+	int has_remote;
 
 	/* miro/pinnacle + Aimslab VHX
 	   philips matchbox (tea5757 radio tuner) support */
Index: drivers/media/video/cpia.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/media/video/cpia.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/media/video/cpia.c	22 Jul 2004 19:50:18 -0000	1.1
+++ drivers/media/video/cpia.c	4 Aug 2004 01:29:03 -0000	1.2
@@ -1683,13 +1683,9 @@
 			 * values.             - rich@annexia.org
 			 */
 			if (cam->params.exposure.redComp < 220 ||
-			    cam->params.exposure.redComp > 255 ||
 			    cam->params.exposure.green1Comp < 214 ||
-			    cam->params.exposure.green1Comp > 255 ||
 			    cam->params.exposure.green2Comp < 214 ||
-			    cam->params.exposure.green2Comp > 255 ||
-			    cam->params.exposure.blueComp < 230 ||
-			    cam->params.exposure.blueComp > 255)
+			    cam->params.exposure.blueComp < 230)
 			  {
 			    printk (KERN_WARNING "*_comp parameters have gone AWOL (%d/%d/%d/%d) - reseting them\n",
 				    cam->params.exposure.redComp,
Index: drivers/media/video/cpia.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/media/video/cpia.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/media/video/cpia.h	22 Jul 2004 19:50:18 -0000	1.1
+++ drivers/media/video/cpia.h	4 Aug 2004 01:29:03 -0000	1.2
@@ -393,12 +393,14 @@
 /* ErrorCode */
 #define ERROR_FLICKER_BELOW_MIN_EXP     0x01 /*flicker exposure got below minimum exposure */
 
-#define ALOG(lineno,fmt,args...) printk(fmt,lineno,##args)
-#define LOG(fmt,args...) ALOG((__LINE__),KERN_INFO __FILE__":"__FUNCTION__"(%d):"fmt,##args)
+#define ALOG(function,lineno,fmt,args...) printk(fmt, function, lineno, ##args)
+#define LOG(fmt,args...) ALOG((__FUNCTION__), (__LINE__), \
+			      KERN_INFO __FILE__":%s(%d):"fmt, ##args)
 
 #ifdef _CPIA_DEBUG_
-#define ADBG(lineno,fmt,args...) printk(fmt, jiffies, lineno, ##args)
-#define DBG(fmt,args...) ADBG((__LINE__),KERN_DEBUG __FILE__"(%ld):"__FUNCTION__"(%d):"fmt,##args)
+#define ADBG(function,lineno,fmt,args...) printk(fmt, jiffies, function, lineno, ##args)
+#define DBG(fmt,args...) ADBG((__FUNCTION__), (__LINE__), \
+			      KERN_DEBUG __FILE__"(%ld):%s(%d):"fmt, ##args)
 #else
 #define DBG(fmn,args...) do {} while(0)
 #endif
Index: drivers/media/video/i2c-old.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/media/video/i2c-old.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/media/video/i2c-old.c	22 Jul 2004 19:50:19 -0000	1.1
+++ drivers/media/video/i2c-old.c	4 Aug 2004 01:29:03 -0000	1.2
@@ -45,17 +45,11 @@
 {
 	printk(KERN_INFO "i2c: initialized%s\n",
 		scan ? " (i2c bus scan enabled)" : "");
-	/* anything to do here ? */
-#if defined(CONFIG_VIDEO_BUZ) || defined(CONFIG_VIDEO_CYBERPRO)
+
+#if defined(CONFIG_VIDEO_CYBERPRO)
 	saa7111_init();
 #endif
-#ifdef CONFIG_VIDEO_BUZ
-	saa7185_init();
-#endif
-#ifdef CONFIG_VIDEO_LML33
-	bt819_init();
-	bt856_init();
-#endif
+
 	return 0;
 }
 
@@ -67,10 +61,10 @@
 	int i,j,ack=1;
 	unsigned char addr;
 	LOCK_FLAGS;
-    
+
 	/* probe for device */
 	LOCK_I2C_BUS(bus);
-	for (addr = driver->addr_l; addr <= driver->addr_h; addr += 2) 
+	for (addr = driver->addr_l; addr <= driver->addr_h; addr += 2)
 	{
 		i2c_start(bus);
 		ack = i2c_sendbyte(bus,addr,0);
@@ -102,8 +96,8 @@
 	device->addr = addr;
 
 	/* Attach */
-	
-	if (driver->attach(device)!=0) 
+
+	if (driver->attach(device)!=0)
 	{
 		kfree(device);
 		return;
@@ -129,7 +123,7 @@
 	for (i = 0; i < I2C_DEVICE_MAX; i++)
 		if (device == device->driver->devices[i])
 			break;
-	if (I2C_DEVICE_MAX == i) 
+	if (I2C_DEVICE_MAX == i)
 	{
 		printk(KERN_WARNING "i2c: detach_device #1: device not found: %s\n",
 			device->name);
@@ -141,7 +135,7 @@
 	for (i = 0; i < I2C_DEVICE_MAX; i++)
 		if (device == device->bus->devices[i])
 			break;
-	if (I2C_DEVICE_MAX == i) 
+	if (I2C_DEVICE_MAX == i)
 	{
 		printk(KERN_WARNING "i2c: detach_device #2: device not found: %s\n",
 		       device->name);
@@ -173,19 +167,19 @@
 	busses[i] = bus;
 	bus_count++;
 	REGPRINT(printk("i2c: bus registered: %s\n",bus->name));
-	
+
 	MOD_INC_USE_COUNT;
 
-	if (scan) 
+	if (scan)
 	{
 		/* scan whole i2c bus */
 		LOCK_I2C_BUS(bus);
-		for (i = 0; i < 256; i+=2) 
+		for (i = 0; i < 256; i+=2)
 		{
 			i2c_start(bus);
 			ack = i2c_sendbyte(bus,i,0);
 			i2c_stop(bus);
-			if (!ack) 
+			if (!ack)
 			{
 				printk(KERN_INFO "i2c: scanning bus %s: found device at addr=0x%02x\n",
 					bus->name,i);
@@ -213,20 +207,20 @@
 	for (i = 0; i < I2C_BUS_MAX; i++)
 		if (bus == busses[i])
 			break;
-	if (I2C_BUS_MAX == i) 
+	if (I2C_BUS_MAX == i)
 	{
 		printk(KERN_WARNING "i2c: unregister_bus #1: bus not found: %s\n",
 			bus->name);
 		return -ENODEV;
 	}
-	
+
 	MOD_DEC_USE_COUNT;
-	
+
 	busses[i] = NULL;
 	bus_count--;
 	REGPRINT(printk("i2c: bus unregistered: %s\n",bus->name));
 
-	return 0;    
+	return 0;
 }
 
 /* ----------------------------------------------------------------------- */
@@ -246,9 +240,9 @@
 
 	drivers[i] = driver;
 	driver_count++;
-	
+
 	MOD_INC_USE_COUNT;
-	
+
 	REGPRINT(printk("i2c: driver registered: %s\n",driver->name));
 
 	/* Probe available busses */
@@ -271,7 +265,7 @@
 	for (i = 0; i < I2C_DRIVER_MAX; i++)
 		if (driver == drivers[i])
 			break;
-	if (I2C_DRIVER_MAX == i) 
+	if (I2C_DRIVER_MAX == i)
 	{
 		printk(KERN_WARNING "i2c: unregister_driver: driver not found: %s\n",
 			driver->name);
@@ -279,7 +273,7 @@
 	}
 
 	MOD_DEC_USE_COUNT;
-	
+
 	drivers[i] = NULL;
 	driver_count--;
 	REGPRINT(printk("i2c: driver unregistered: %s\n",driver->name));
@@ -343,7 +337,7 @@
 int i2c_ack(struct i2c_bus *bus)
 {
 	int ack;
-    
+
 	I2C_SET(bus,0,1);
 	I2C_SET(bus,1,1);
 	ack = I2C_GET(bus);
@@ -354,7 +348,7 @@
 int i2c_sendbyte(struct i2c_bus *bus,unsigned char data,int wait_for_ack)
 {
 	int i, ack;
-    
+
 	I2C_SET(bus,0,0);
 	for (i=7; i>=0; i--)
 		(data&(1<<i)) ? i2c_one(bus) : i2c_zero(bus);
@@ -369,9 +363,9 @@
 {
 	int i;
 	unsigned char data=0;
-    
+
 	I2C_SET(bus,0,1);
-	for (i=7; i>=0; i--) 
+	for (i=7; i>=0; i--)
 	{
 		I2C_SET(bus,1,1);
 		if (I2C_GET(bus))
@@ -388,7 +382,7 @@
 int i2c_read(struct i2c_bus *bus, unsigned char addr)
 {
 	int ret;
-    
+
 	if (bus->i2c_read)
 		return bus->i2c_read(bus, addr);
 
Index: drivers/media/video/id.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/media/video/id.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/media/video/id.h	22 Jul 2004 19:50:18 -0000	1.1
+++ drivers/media/video/id.h	4 Aug 2004 01:29:03 -0000	1.2
@@ -27,6 +27,9 @@
 #ifndef  I2C_DRIVERID_TDA9874
 # define I2C_DRIVERID_TDA9874 I2C_DRIVERID_EXP0+7
 #endif
+#ifndef  I2C_DRIVERID_SAA6752HS
+# define I2C_DRIVERID_SAA6752HS I2C_DRIVERID_EXP0+8
+#endif
 
 /* algorithms */
 #ifndef I2C_ALGO_SAA7134
Index: drivers/media/video/meye.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/media/video/meye.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/media/video/meye.c	22 Jul 2004 19:50:19 -0000	1.1
+++ drivers/media/video/meye.c	4 Aug 2004 01:29:03 -0000	1.2
@@ -35,7 +35,6 @@
 #include <asm/uaccess.h>
 #include <asm/io.h>
 #include <linux/delay.h>
-#include <linux/wrapper.h>
 #include <linux/interrupt.h>
 #include <linux/vmalloc.h>
 
@@ -139,7 +138,7 @@
 		memset(mem, 0, size); /* Clear the ram out, no junk to the user */
 	        adr = (unsigned long)mem;
 		while (size > 0) {
-			mem_map_reserve(vmalloc_to_page((void *)adr));
+			SetPageReserved(vmalloc_to_page((void *)adr));
 			adr += PAGE_SIZE;
 			size -= PAGE_SIZE;
 		}
@@ -153,7 +152,7 @@
 	if (mem) {
 	        adr = (unsigned long) mem;
 		while ((long) size > 0) {
-			mem_map_unreserve(vmalloc_to_page((void *)adr));
+			ClearPageReserved(vmalloc_to_page((void *)adr));
 			adr += PAGE_SIZE;
 			size -= PAGE_SIZE;
 		}
@@ -161,35 +160,78 @@
 	}
 }
 
-/* return a page table pointing to N pages of locked memory */
+/****************************************************************************/
+/* dma_alloc_coherent / dma_free_coherent ported from 2.5                  */
+/****************************************************************************/
+
+void *dma_alloc_coherent(struct pci_dev *dev, size_t size,
+                           dma_addr_t *dma_handle, int gfp)
+{
+        void *ret;
+        /* ignore region specifiers */
+        gfp &= ~(__GFP_DMA | __GFP_HIGHMEM);
+
+        if (dev == NULL || ((u32)dev->dma_mask < 0xffffffff))
+                gfp |= GFP_DMA;
+        ret = (void *)__get_free_pages(gfp, get_order(size));
+
+        if (ret != NULL) { 
+                memset(ret, 0, size);
+                *dma_handle = virt_to_phys(ret);
+        }       
+        return ret;
+}
+
+void dma_free_coherent(struct pci_dev *dev, size_t size,
+                         void *vaddr, dma_addr_t dma_handle)
+{
+        free_pages((unsigned long)vaddr, get_order(size));
+}
+
+/*
+ * return a page table pointing to N pages of locked memory
+ *
+ * NOTE: The meye device expects dma_addr_t size to be 32 bits
+ * (the toc must be exactly 1024 entries each of them being 4 bytes
+ * in size, the whole result being 4096 bytes). We're using here
+ * dma_addr_t for correctness but the compilation of this driver is
+ * disabled for HIGHMEM64G=y, where sizeof(dma_addr_t) != 4
+ */
 static int ptable_alloc(void) {
-	u32 *pt;
+	dma_addr_t *pt;
 	int i;
 
 	memset(meye.mchip_ptable, 0, sizeof(meye.mchip_ptable));
 
-	meye.mchip_ptable[MCHIP_NB_PAGES] = pci_alloc_consistent(meye.mchip_dev, 
-								 PAGE_SIZE, 
-								 &meye.mchip_dmahandle);
-	if (!meye.mchip_ptable[MCHIP_NB_PAGES]) {
+	meye.mchip_ptable_toc = dma_alloc_coherent(meye.mchip_dev, 
+						   PAGE_SIZE, 
+						   &meye.mchip_dmahandle,
+						   GFP_KERNEL);
+	if (!meye.mchip_ptable_toc) {
 		meye.mchip_dmahandle = 0;
 		return -1;
 	}
 
-	pt = (u32 *)meye.mchip_ptable[MCHIP_NB_PAGES];
+	pt = meye.mchip_ptable_toc;
 	for (i = 0; i < MCHIP_NB_PAGES; i++) {
-		meye.mchip_ptable[i] = pci_alloc_consistent(meye.mchip_dev, 
-							    PAGE_SIZE,
-							    pt);
+		meye.mchip_ptable[i] = dma_alloc_coherent(meye.mchip_dev, 
+							  PAGE_SIZE,
+							  pt,
+							  GFP_KERNEL);
 		if (!meye.mchip_ptable[i]) {
 			int j;
-			pt = (u32 *)meye.mchip_ptable[MCHIP_NB_PAGES];
+			pt = meye.mchip_ptable_toc;
 			for (j = 0; j < i; ++j) {
-				pci_free_consistent(meye.mchip_dev,
-						    PAGE_SIZE,
-						    meye.mchip_ptable[j], *pt);
+				dma_free_coherent(meye.mchip_dev,
+						  PAGE_SIZE,
+						  meye.mchip_ptable[j], *pt);
 				pt++;
 			}
+			dma_free_coherent(meye.mchip_dev,
+					  PAGE_SIZE,
+					  meye.mchip_ptable_toc,
+					  meye.mchip_dmahandle);
+			meye.mchip_ptable_toc = 0;
 			meye.mchip_dmahandle = 0;
 			return -1;
 		}
@@ -199,25 +241,26 @@
 }
 
 static void ptable_free(void) {
-	u32 *pt;
+	dma_addr_t *pt;
 	int i;
 
-	pt = (u32 *)meye.mchip_ptable[MCHIP_NB_PAGES];
+	pt = meye.mchip_ptable_toc;
 	for (i = 0; i < MCHIP_NB_PAGES; i++) {
 		if (meye.mchip_ptable[i])
-			pci_free_consistent(meye.mchip_dev, 
-					    PAGE_SIZE, 
-					    meye.mchip_ptable[i], *pt);
+			dma_free_coherent(meye.mchip_dev, 
+					  PAGE_SIZE, 
+					  meye.mchip_ptable[i], *pt);
 		pt++;
 	}
 
-	if (meye.mchip_ptable[MCHIP_NB_PAGES])
-		pci_free_consistent(meye.mchip_dev, 
-				    PAGE_SIZE, 
-				    meye.mchip_ptable[MCHIP_NB_PAGES], 
-				    meye.mchip_dmahandle);
+	if (meye.mchip_ptable_toc)
+		dma_free_coherent(meye.mchip_dev, 
+				  PAGE_SIZE, 
+				  meye.mchip_ptable_toc,
+				  meye.mchip_dmahandle);
 
 	memset(meye.mchip_ptable, 0, sizeof(meye.mchip_ptable));
+	meye.mchip_ptable_toc = 0;
 	meye.mchip_dmahandle = 0;
 }
 
@@ -614,25 +657,25 @@
 /* stop any existing HIC action and wait for any dma to complete then
    reset the dma engine */
 static void mchip_hic_stop(void) {
-	int i = 0;
+	int i, j;
 
 	meye.mchip_mode = MCHIP_HIC_MODE_NOOP;
-	if (!(mchip_read(MCHIP_HIC_STATUS) & MCHIP_HIC_STATUS_BUSY)) 
+	if (!(mchip_read(MCHIP_HIC_STATUS) & MCHIP_HIC_STATUS_BUSY))
 		return;
-	mchip_set(MCHIP_HIC_CMD, MCHIP_HIC_CMD_STOP);
-	mchip_delay(MCHIP_HIC_CMD, 0);
-	while (!mchip_delay(MCHIP_HIC_STATUS, MCHIP_HIC_STATUS_IDLE)) {
-		/*  resetting HIC */
+	for (i = 0; i < 20; ++i) {
 		mchip_set(MCHIP_HIC_CMD, MCHIP_HIC_CMD_STOP);
 		mchip_delay(MCHIP_HIC_CMD, 0);
+		for (j = 0; j < 100; ++j) {
+			if (mchip_delay(MCHIP_HIC_STATUS, MCHIP_HIC_STATUS_IDLE))
+				return;
+			wait_ms(1);
+		}
+		printk(KERN_ERR "meye: need to reset HIC!\n");
+	
 		mchip_set(MCHIP_HIC_CTL, MCHIP_HIC_CTL_SOFT_RESET);
 		wait_ms(250);
-		if (i++ > 20) {
-			printk(KERN_ERR "meye: resetting HIC hanged!\n");
-			break;
-		}
 	}
-	wait_ms(100);
+	printk(KERN_ERR "meye: resetting HIC hanged!\n");
 }
 
 /****************************************************************************/
@@ -833,7 +876,7 @@
 /* Interrupt handling                                                       */
 /****************************************************************************/
 
-static void meye_irq(int irq, void *dev_id, struct pt_regs *regs) {
+static irqreturn_t meye_irq(int irq, void *dev_id, struct pt_regs *regs) {
 	u32 v;
 	int reqnr;
 	v = mchip_read(MCHIP_MM_INTA);
@@ -841,7 +884,7 @@
 	while (1) {
 		v = mchip_get_frame();
 		if (!(v & MCHIP_MM_FIR_RDY))
-			return;
+			return IRQ_NONE;
 		switch (meye.mchip_mode) {
 
 		case MCHIP_HIC_MODE_CONT_OUT:
@@ -874,11 +917,12 @@
 
 		default:
 			/* do not free frame, since it can be a snap */
-			return;
+			return IRQ_NONE;
 		} /* switch */
 
 		mchip_free_frame();
 	}
+	return IRQ_HANDLED;
 }
 
 /****************************************************************************/
@@ -918,7 +962,7 @@
 
 	case VIDIOCGCAP: {
 		struct video_capability *b = arg;
-		strcpy(b->name,meye.video_dev.name);
+		strcpy(b->name,meye.video_dev->name);
 		b->type = VID_TYPE_CAPTURE;
 		b->channels = 1;
 		b->audios = 0;
@@ -1223,6 +1267,8 @@
 	.type		= VID_TYPE_CAPTURE,
 	.hardware	= VID_HARDWARE_MEYE,
 	.fops		= &meye_fops,
+	.release	= video_device_release,
+	.minor		= -1,
 };
 
 #ifdef CONFIG_PM
@@ -1273,10 +1319,16 @@
 		goto out1;
 	}
 
-	sonypi_camera_command(SONYPI_COMMAND_SETCAMERA, 1);
-
 	meye.mchip_dev = pcidev;
-	memcpy(&meye.video_dev, &meye_template, sizeof(meye_template));
+	meye.video_dev = video_device_alloc();
+	if (!meye.video_dev) {
+		printk(KERN_ERR "meye: video_device_alloc() failed!\n");
+		ret = -EBUSY;
+		goto out1;
+	}
+	memcpy(meye.video_dev, &meye_template, sizeof(meye_template));
+
+	sonypi_camera_command(SONYPI_COMMAND_SETCAMERA, 1);
 
 	if ((ret = pci_enable_device(meye.mchip_dev))) {
 		printk(KERN_ERR "meye: pci_enable_device failed\n");
@@ -1333,7 +1385,7 @@
 	wait_ms(1);
 	mchip_set(MCHIP_MM_INTA, MCHIP_MM_INTA_HIC_1_MASK);
 
-	if (video_register_device(&meye.video_dev, VFL_TYPE_GRABBER, video_nr) < 0) {
+	if (video_register_device(meye.video_dev, VFL_TYPE_GRABBER, video_nr) < 0) {
 
 		printk(KERN_ERR "meye: video_register_device failed\n");
 		ret = -EIO;
@@ -1381,6 +1433,9 @@
 out3:
 	pci_disable_device(meye.mchip_dev);
 out2:
+	video_device_release(meye.video_dev);
+	meye.video_dev = NULL;
+
 	sonypi_camera_command(SONYPI_COMMAND_SETCAMERA, 0);
 out1:
 	return ret;
@@ -1388,10 +1443,12 @@
 
 static void __devexit meye_remove(struct pci_dev *pcidev) {
 
-	video_unregister_device(&meye.video_dev);
+	video_unregister_device(meye.video_dev);
 
 	mchip_hic_stop();
 
+	mchip_dma_free();
+
 	/* disable interrupts */
 	mchip_set(MCHIP_MM_INTA, 0x0);
 
@@ -1404,8 +1461,6 @@
 
 	pci_disable_device(meye.mchip_dev);
 
-	mchip_dma_free();
-
 	if (meye.grab_fbuffer)
 		rvfree(meye.grab_fbuffer, gbuffers*gbufsize);
 
@@ -1414,7 +1469,7 @@
 	printk(KERN_INFO "meye: removed\n");
 }
 
-static struct pci_device_id meye_pci_tbl[] __devinitdata = {
+static struct pci_device_id meye_pci_tbl[] = {
 	{ PCI_VENDOR_ID_KAWASAKI, PCI_DEVICE_ID_MCHIP_KL5A72002, 
 	  PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0 },
 	{ }
@@ -1474,8 +1529,6 @@
 MODULE_DESCRIPTION("video4linux driver for the MotionEye camera");
 MODULE_LICENSE("GPL");
 
-EXPORT_NO_SYMBOLS;
-
 MODULE_PARM(gbuffers,"i");
 MODULE_PARM_DESC(gbuffers,"number of capture buffers, default is 2 (32 max)");
 MODULE_PARM(gbufsize,"i");
Index: drivers/media/video/meye.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/media/video/meye.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/media/video/meye.h	22 Jul 2004 19:50:19 -0000	1.1
+++ drivers/media/video/meye.h	4 Aug 2004 01:29:03 -0000	1.2
@@ -31,13 +31,11 @@
 #define _MEYE_PRIV_H_
 
 #define MEYE_DRIVER_MAJORVERSION	1
-#define MEYE_DRIVER_MINORVERSION	6
+#define MEYE_DRIVER_MINORVERSION	9
 
 #include <linux/config.h>
 #include <linux/types.h>
 #include <linux/pci.h>
-#include <linux/sonypi.h>
-#include <linux/meye.h>
 
 /****************************************************************************/
 /* Motion JPEG chip registers                                               */
@@ -300,7 +298,8 @@
 	u8 mchip_fnum;			/* current mchip frame number */
 
 	unsigned char *mchip_mmregs;	/* mchip: memory mapped registers */
-	u8 *mchip_ptable[MCHIP_NB_PAGES+1];/* mchip: ptable + ptable toc */
+	u8 *mchip_ptable[MCHIP_NB_PAGES];/* mchip: ptable */
+	dma_addr_t *mchip_ptable_toc;	/* mchip: ptable toc */
 	dma_addr_t mchip_dmahandle;	/* mchip: dma handle to ptable toc */
 
 	unsigned char *grab_fbuffer;	/* capture framebuffer */
@@ -312,7 +311,7 @@
 
 	struct meye_queue grabq;	/* queue for buffers to be grabbed */
 
-	struct video_device video_dev;	/* video device parameters */
+	struct video_device *video_dev;	/* video device parameters */
 	struct video_picture picture;	/* video picture parameters */
 	struct meye_params params;	/* additional parameters */
 #ifdef CONFIG_PM
